﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace prjPizzaOrder
{
    public partial class frmMain : Form
    {
        private double _pizzaSub = 0.00;
        private double _size = 0.00;
        private double _crust = 0.00;
        private int _toppings = 0;
        private double _beverage = 1.49;
        private double _extras = 0.00;

        public frmMain()
        {
            InitializeComponent();
        }

        #region "Pizza Controls"

        private void frmMain_Load(object sender, EventArgs e)
        {
            // Populate Pizza size control
            this.cboSize.Items.Add(Properties.Settings.Default.Size1);
            this.cboSize.Items.Add(Properties.Settings.Default.Size2);
            this.cboSize.Items.Add(Properties.Settings.Default.Size3);
            this.cboSize.SelectedIndex = 0;

            // Populate Pizza crust control
            this.cboCrust.Items.Add(Properties.Settings.Default.Crust1);
            this.cboCrust.Items.Add(Properties.Settings.Default.Crust2);
            this.cboCrust.Items.Add(Properties.Settings.Default.Crust3);
            this.cboCrust.Items.Add(Properties.Settings.Default.Crust4);
            this.cboCrust.SelectedIndex = 0;

            // Populate Pizza topping control
            this.clbToppings.Items.Add(Properties.Settings.Default.Topping1);
            this.clbToppings.Items.Add(Properties.Settings.Default.Topping2);
            this.clbToppings.Items.Add(Properties.Settings.Default.Topping3);
            this.clbToppings.Items.Add(Properties.Settings.Default.Topping4);
            this.clbToppings.Items.Add(Properties.Settings.Default.Topping5);
            this.clbToppings.Items.Add(Properties.Settings.Default.Topping6);
        }

        private void cboSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Calculate pizza size total
            if (cboSize.Text == "Small")
            {
                _size = 6.99;
            }
            else if (cboSize.Text == "Medium")
            {
                _size = 9.99;
            }
            else if (cboSize.Text == "Large")
            {
                _size = 14.99;
            }
            else
            {
                _size = 0.00;
            }

            CalculatePizzaSubTotal();
        }

        private void cboCrust_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Calculate pizza crust total
            if (cboCrust.Text == "Hand Tossed")
            {
                _crust = 0.00;
            }
            else if (cboCrust.Text == "Chicago Style")
            {
                _crust = 2.50;
            }
            else if (cboCrust.Text == "Deep Dish")
            {
                _crust = 5.50;
            }
            else if (cboCrust.Text == "Stuffed Crust")
            {
                _crust = 3.50;
            }
            else
            {
                _crust = 0.00;
            }

            CalculatePizzaSubTotal();
        }

        private void clbToppings_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Calculate pizza toppings total
            _toppings = clbToppings.SelectedItems.Count; // Not doing the trick, not sure why...
            CalculatePizzaSubTotal();
        }

        private void CalculatePizzaSubTotal()
        {
            // Calculate pizza sub total and display in labels
            _pizzaSub = _size + _crust + (_toppings * .50);
            lblPizzaSub.Text = "$" + _pizzaSub.ToString();
            lblPizzaSub2.Text = "$" + _pizzaSub.ToString();
            CalculateTotal();
        }

        #endregion

        #region "Beverage Controls"

        private void Beverages_CheckedChanged(object sender, EventArgs e)
        {
            if (((Control)sender).Tag == "Soda")
            {
                _beverage = 1.49;
            }
            else if (((Control)sender).Tag == "NotSoda")
            {
                _beverage = 0.99;
            }

            CalculateBeverageSubTotal();
        }

        private void CalculateBeverageSubTotal()
        {
            // Calculate beverage sub total and display in labels
            lblBeveragesSub.Text = "$" + _beverage.ToString();
            lblBeveragesSub2.Text = "$" + _beverage.ToString();
            CalculateTotal();
        }

        #endregion

        #region "Extras Controls"

        private void chkBreadSticks_CheckedChanged(object sender, EventArgs e)
        {
            if (((CheckBox)sender).Checked == true)
            {
                _extras = _extras + Convert.ToDouble(((Control)sender).Tag);
            }
            else if (((CheckBox)sender).Checked == false)
            {
                _extras = _extras - Convert.ToDouble(((Control)sender).Tag);
            }

            CalculateExtrasSubTotal();
        }

        private void CalculateExtrasSubTotal()
        {
            // Calculate beverage sub total and display in labels
            lblExtrasSub.Text = "$" + _extras.ToString();
            lblExtrasSub2.Text = "$" + _extras.ToString();
            CalculateTotal();
        }

        #endregion

        private void CalculateTotal()
        {
            // Calculate the total
            lblTotalCost.Text = String.Format("{0:C}", (_pizzaSub + _beverage + _extras));
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            // Close program
            this.Close();
        }

        private void btnPlaceOrder_Click(object sender, EventArgs e)
        {
            frmMessageBox Form2 = new frmMessageBox();
            Form2._pizzaSize = cboSize.SelectedItem.ToString();
            Form2._crustType = cboCrust.SelectedItem.ToString();

            List<string> Toppings = new List<string>();
            List<string> Extras = new List<string>();

            foreach (string value in clbToppings.CheckedItems)
            {
                Toppings.Add(value);
            }
            Form2._toppings = Toppings;

            foreach (Control ctrl in tabPage2.Controls)
            {
                if (ctrl is RadioButton)
                {
                    if (((RadioButton)(ctrl)).Checked) // For some reason, is being skipped over...
                    {
                        Form2._beverage = ((RadioButton)(ctrl)).Text;
                        break;
                    }
                }
            }
            foreach (Control ctrl in tabPage3.Controls)
            {
                if (ctrl is CheckBox)
                {
                    if (((CheckBox)(ctrl)).Checked) // For some reason, is being skipped over...
                    {
                        Extras.Add(((CheckBox)(ctrl)).Text);
                    }
                }
            }
            Form2._extras = Extras;

            Form2.Show();
        }
    }
}
